define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var MetaServiceHelper = /** @class */ (function () {
        function MetaServiceHelper() {
        }
        MetaServiceHelper.addMetaTags = function (tags) {
            var head = document.getElementsByTagName('head')[0];
            tags.forEach(function (tag) {
                var meta = document.createElement('meta');
                if (tag["charset"]) {
                    var charset = tag;
                    meta.setAttribute('charset', charset.charset);
                    head.appendChild(meta);
                    return;
                }
                else if (tag["httpEquiv"]) {
                    var http_equiv = tag;
                    meta.setAttribute('http-equiv', http_equiv.httpEquiv);
                }
                else if (tag["property"]) {
                    var named = tag;
                    meta.setAttribute('property', named.property);
                }
                else {
                    var named = tag;
                    meta.setAttribute('name', named.name);
                }
                meta.setAttribute('content', tag.content ? tag.content : "");
                head.appendChild(meta);
            });
        };
        MetaServiceHelper.removeMetaTags = function (tags) {
            var head = document.getElementsByTagName('head')[0];
            tags.forEach(function (tag) {
                var isNamed = tag["name"] ? true : false;
                var current = undefined;
                if (isNamed)
                    current = tag;
                else
                    current = tag;
                var meta = isNamed
                    ? head.querySelectorAll("meta[name=\"" + current.name + "\"]")
                    : head.querySelectorAll("meta[property=\"" + current.property + "\"]");
                if (meta) {
                    meta.forEach(function (m) { return m.remove(); });
                }
            });
        };
        return MetaServiceHelper;
    }());
    exports.MetaServiceHelper = MetaServiceHelper;
});
