System.register(["aurelia-framework", "aurelia-event-aggregator", "aurelia-router", "./router-extend", "./meta-service-helper"], function (exports_1, context_1) {
    "use strict";
    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = (this && this.__metadata) || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var aurelia_framework_1, aurelia_event_aggregator_1, aurelia_router_1, meta_service_helper_1, AureliaMetaService;
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [
            function (aurelia_framework_1_1) {
                aurelia_framework_1 = aurelia_framework_1_1;
            },
            function (aurelia_event_aggregator_1_1) {
                aurelia_event_aggregator_1 = aurelia_event_aggregator_1_1;
            },
            function (aurelia_router_1_1) {
                aurelia_router_1 = aurelia_router_1_1;
            },
            function (_1) {
            },
            function (meta_service_helper_1_1) {
                meta_service_helper_1 = meta_service_helper_1_1;
            }
        ],
        execute: function () {
            AureliaMetaService = /** @class */ (function () {
                function AureliaMetaService(ea, router) {
                    this.ea = ea;
                    this.router = router;
                    this.start();
                }
                AureliaMetaService_1 = AureliaMetaService;
                // #region for my own further reference
                // private getTags(route: NavigationInstruction): Array<INamedMetaTag | IPropertyMetaTag> {
                //   let nextTags: Array<INamedMetaTag | IPropertyMetaTag> = [];
                //   if (Object.keys(route.viewPortInstructions).length) {
                //     for (let viewport in route.viewPortInstructions) {
                //       if (route.viewPortInstructions[viewport].childNavigationInstruction) {
                //         const tags = this.getTags(route.viewPortInstructions[viewport].childNavigationInstruction);
                //         if (tags) {
                //           tags.forEach(tag => nextTags.push(tag));
                //         }
                //       }
                //     }
                //   }
                //   if( route.config.meta && route.config.meta.length ){
                //     route.config.meta.forEach(meta => nextTags.push(meta));
                //   }
                //   return nextTags;
                // }
                // #endregion
                AureliaMetaService.prototype.registerCompleteRouteEvent = function () {
                    this.completeSubscription = this.ea.subscribe(AureliaMetaService_1.COMPLETE_ROUTE_EVENT, function (payload) {
                        if (payload.result.completed) {
                            var tags = payload.instruction.getAllInstructions().flatMap(function (inst) { return inst.config.meta; });
                            meta_service_helper_1.MetaServiceHelper.addMetaTags(tags);
                        }
                    });
                };
                AureliaMetaService.prototype.registerProcessingRouteEvent = function () {
                    this.processingSubscription = this.ea.subscribe(AureliaMetaService_1.PROCESSING_ROUTE_EVENT, function (payload) {
                        var prevInstruction = payload.instruction.previousInstruction;
                        if (prevInstruction) {
                            var prevTags = prevInstruction.getAllInstructions().flatMap(function (inst) { return inst.config.meta; });
                            if (prevTags) {
                                meta_service_helper_1.MetaServiceHelper.removeMetaTags(prevTags);
                            }
                        }
                    });
                };
                AureliaMetaService.prototype.start = function () {
                    if (this.processingSubscription && this.completeSubscription) {
                        return;
                    }
                    this.registerCompleteRouteEvent();
                    this.registerProcessingRouteEvent();
                };
                AureliaMetaService.prototype.stop = function () {
                    this.completeSubscription.dispose();
                    this.processingSubscription.dispose();
                    this.completeSubscription = null;
                    this.processingSubscription = null;
                    delete this.completeSubscription;
                    delete this.processingSubscription;
                };
                AureliaMetaService.prototype.addTag = function (tag) {
                    meta_service_helper_1.MetaServiceHelper.addMetaTags([tag]);
                };
                AureliaMetaService.prototype.addTags = function (tags) {
                    meta_service_helper_1.MetaServiceHelper.addMetaTags(tags);
                };
                AureliaMetaService.prototype.removeTag = function (tag) {
                    meta_service_helper_1.MetaServiceHelper.removeMetaTags([tag]);
                };
                AureliaMetaService.prototype.removeTags = function (tags) {
                    meta_service_helper_1.MetaServiceHelper.removeMetaTags(tags);
                };
                var AureliaMetaService_1;
                AureliaMetaService.PROCESSING_ROUTE_EVENT = "router:navigation:processing";
                AureliaMetaService.COMPLETE_ROUTE_EVENT = "router:navigation:complete";
                AureliaMetaService = AureliaMetaService_1 = __decorate([
                    aurelia_framework_1.inject(aurelia_event_aggregator_1.EventAggregator, aurelia_router_1.Router),
                    aurelia_framework_1.singleton(),
                    __metadata("design:paramtypes", [aurelia_event_aggregator_1.EventAggregator, aurelia_router_1.Router])
                ], AureliaMetaService);
                return AureliaMetaService;
            }());
            exports_1("AureliaMetaService", AureliaMetaService);
        }
    };
});
